﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Silverlight.Samples;
using System.Windows.Media.Imaging;
using FluxJpeg.Core;
using FluxJpeg.Core.Decoder;
using System.IO;

namespace Water
{
    public partial class Page : UserControl
    {
        DispatcherTimer mainTimer;
        PngEncoder surface;
        int width, height;
        Renderer renderer;
        FluxJpeg.Core.Image fluxImage;

        public Page()
        {
            InitializeComponent();

            ctlEmbed.TextToEmbed = @"<iframe src=""http://silverlight.services.live.com/invoke/61093/RainDrops/iframe.html"" scrolling=""no"" frameborder=""0"" style=""width:532px; height:446px""></iframe>";

            width = (int)imgWater.Width;
            height = (int)imgWater.Height;
            surface = new PngEncoder(width, height);
            renderer = new Renderer(width, height);
            renderer.Splash(100, 100, 1);

            LoadBackgroundImage();

            mainTimer = new DispatcherTimer();
            mainTimer.Interval = TimeSpan.FromMilliseconds(60);
            mainTimer.Tick += new EventHandler(mainTimer_Tick);
            mainTimer.Start();

        }

        Random r = new Random();
        void mainTimer_Tick(object sender, EventArgs e)
        {
            renderer.Splash(r.Next(width), r.Next(height), r.Next(4));

            renderer.Step();
            renderer.Display(surface, fluxImage);
            BitmapImage img = new BitmapImage();

            img.SetSource(surface.GetImageStream());
            imgWater.Source = img;
        }

        private string GetString(Stream s)
        {
            byte[] buf = new byte[s.Length];
            s.Read(buf, 0, (int)s.Length);
            System.Text.StringBuilder sb = new System.Text.StringBuilder(buf.Length);
            for (int i = 0; i < buf.Length; i++)
            {
                sb.AppendFormat("{0}: {1}\r\n", i, buf[i]);
            }

            return sb.ToString();
        }

        private void imgWater_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            System.Windows.Point pos = e.GetPosition(imgWater);
            renderer.Splash((int) pos.X, (int) pos.Y, 4);
        }

        private void LoadBackgroundImage()
        {
            System.IO.Stream input = this.GetType().Assembly.GetManifestResourceStream("Water.bg.jpg");
            DecodedJpeg jpeg = new JpegDecoder(input).Decode();
            // resize if needed !!!
            fluxImage = jpeg.Image.ChangeColorSpace(ColorSpace.RGB);
        }

        private void imgWater_MouseMove(object sender, MouseEventArgs e)
        {
            System.Windows.Point pos = e.GetPosition(imgWater);
            renderer.Splash((int)pos.X, (int)pos.Y, 1);
        }

        private void EmbedThis_Click(object sender, RoutedEventArgs e)
        {
            ctlEmbed.Appear();
        }
    }
}
